#include <time.h>
#include <stdio.h> 
#include <unistd.h> 
#include <errno.h> 
#include <semaphore.h>
#include <string.h>

#include "premise_conclusion.h"
#include "md5.h"


void md5ify(char *inString, char *outString) {
	md5_state_t state;
	md5_byte_t digest[16];
    int i;
    
	md5_init(&state);
	md5_append(&state, (const md5_byte_t *)inString, strlen(inString));
	md5_finish(&state, digest);

    for (i = 0; i < 16; i++)
        sprintf(&outString[i * 2], "%02x", digest[i]);
}

void say(const char *pName, char *pMessage) {
    time_t the_time;
    struct tm *the_localtime;
    char timestamp[256];
    
    the_time = time(NULL);
    
    the_localtime = localtime(&the_time);
    
    strftime(timestamp, 255, "%H:%M:%S", the_localtime);
    
    printf("%s @ %s: %s\n", pName, timestamp, pMessage);
    
}


int release_semaphore(const char *pName, sem_t *pSemaphore) {
    int rc = 0;
    char s[1024];
    
    say(pName, "Releasing the semaphore.");
    
    if (!LIVE_DANGEROUSLY) {
        rc = sem_post(pSemaphore);
        if (rc) {
            sprintf(s, "Releasing the semaphore failed; errno is %d\n", errno);
            say(pName, s);
        }
    }
    
    return rc;
}

int acquire_semaphore(const char *pName, sem_t *pSemaphore) {
    int rc = 0;
    char s[1024];

    say(pName, "Waiting to acquire the semaphore.");

    if (!LIVE_DANGEROUSLY) {
        rc = sem_wait(pSemaphore);
        if (rc) {
            sprintf(s, "Acquiring the semaphore failed; errno is %d\n", errno);
            say(pName, s);
        }
    }

    return rc;
}
